<?php
// initialisiere Variablen

function counter($id, $dir, $info) {

    if (trim($id)=="") { // Werte nie ohne passende ID speichern!
      return 0;
    }

    global $REMOTE_ADDR;
    $datFile = $dir."statistik.cnt";
    $ipFile  = $dir.$id.".ip";
    $heute   = time();
    $hit     = false;
    $usedIp  = false;
    $count   = 1;
    $info    = rawurlencode($info);

    $ip = $REMOTE_ADDR;

    if (! file_exists("$ipFile")) {
      fclose(fopen("$ipFile", "w+"));
    }

    // Dateien ffnen / sperren
    if ((!file_exists("$datFile") || (is_readable("$datFile") && is_writeable("$datFile")) ) && is_readable("$ipFile") && is_writeable("$ipFile")) {

        $daten = array();
        if (file_exists("$datFile")) { $daten = file("$datFile"); }
        $besucher = file("$ipFile"); $IPdatei = fopen("$ipFile", "w+"); flock($IPdatei, 2);

        // prfe ob IP frher schon verwendet wurde
        for ($i=0;$i<count($besucher);$i++) {
          $test = explode("=", $besucher[$i]);
          // Eintrag ist abgelaufen?
          if ($test[1] < $heute) { $besucher[$i] = "";
          } elseif ($test[0] == $ip) {
            $usedIp = true;
            break; // IP gefunden - wir sind fertig
          }
        }

        // fr eine neue IP einen Eintrag erstellen
        if (!$usedIp) {
          $besucher[count($besucher)] = $ip."=".($heute+10000)."\n";
        }

        // IP-Datei speichern und schliessen
        fwrite($IPdatei, implode("", $besucher));
        flock($IPdatei, 3); fclose($IPdatei);

        // prfe ob Eintrag vorhanden
        for ($i=0;$i<count($daten);$i++) {
          $test        = explode("=", $daten[$i]);
          if($test[0] == $id) {
            $count     = (int) $test[1];
            if (!$usedIp) { $count += 1; }
            $daten[$i] = $test[0] . "=$count" . ( ($test[0] != $info) ? "=$info" : '' ) . "\n";
            $hit       = true;
            break; // Eintrag gefunden - wir sind fertig
          }
        }

        // wenn kein Eintrag vorhanden ist, fge einen hinzu

        if (!$hit) {
          $daten[count($daten)] = $id . "=$count" . ( ($id != $info) ? "=$info" : '' ) . "\n";
        }

        // speichere den neuen Zhlerstand / schliesse die Datei
        if (! file_exists("$datFile")) {
          $DATdatei = fopen("$datFile", "w+"); flock($DATdatei, 2);
          fwrite($DATdatei, implode("", $daten));
          flock($DATdatei, 3); fclose($DATdatei);
        } elseif (!$usedIp && (count($daten) > 0) && ((!$hit && $count == 1) || ($hit && $count > 1))) {
          $DATdatei = fopen("$datFile", "w"); flock($DATdatei, 2);
          fwrite($DATdatei, implode("", $daten));
          flock($DATdatei, 3); fclose($DATdatei);
        }

    } // end if

    return $count;

}

function getCounter($id, $dir) {

    $datFile = $dir."statistik.cnt";
    $count   = 1;

    // Dateien ffnen / sperren
    if (!file_exists("$datFile") || is_readable("$datFile")) {

        $daten = array();
        if (file_exists("$datFile")) { $daten = file("$datFile"); }

        // prfe ob Eintrag vorhanden
        for ($i=0;$i<count($daten);$i++) {
          $test        = explode("=", $daten[$i]);
          if($test[0] == $id) {
            $count     = (int) $test[1];
            break; // Eintrag gefunden - wir sind fertig
          }
        }

    } // end if

    return $count;

}

?>
